<?xml version="1.0" encoding="UTF-8"?>
<!-- Default Primary Audio HAL Module Audio Policy Configuration include flie -->
<module name="primary" halVersion="2.0">
    <attachedDevices>
        <item>Speaker</item>
        <item>Earpiece</item>
        <item>Built-In Mic</item>
        <item>Built-In Back Mic</item>
        <item>Fm Record Device</item>
        <item>Telephony Rx</item>
        <item>Telephony Tx</item>
    </attachedDevices>
    <defaultOutputDevice>Speaker</defaultOutputDevice>
    <mixPorts>
        <mixPort name="primary output" role="source" flags="AUDIO_OUTPUT_FLAG_PRIMARY">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="48000" channelMasks="AUDIO_CHANNEL_OUT_STEREO"/>
        </mixPort>
        <mixPort name="fast output" role="source" flags="AUDIO_OUTPUT_FLAG_FAST">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="48000" channelMasks="AUDIO_CHANNEL_OUT_STEREO"/>
        </mixPort>
        <mixPort name="mmap_no_irq_out" role="source" flags="AUDIO_OUTPUT_FLAG_DIRECT AUDIO_OUTPUT_FLAG_MMAP_NOIRQ">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="48000" channelMasks="AUDIO_CHANNEL_OUT_STEREO"/>
        </mixPort>
        <mixPort name="voip_rx" role="source" flags="AUDIO_OUTPUT_FLAG_VOIP_RX">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 16000 32000 48000" channelMasks="AUDIO_CHANNEL_OUT_MONO AUDIO_CHANNEL_OUT_STEREO"/>
        </mixPort>
        <mixPort name="incall_music" role="source" flags="AUDIO_OUTPUT_FLAG_INCALL_MUSIC">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 16000 32000 48000" channelMasks="AUDIO_CHANNEL_OUT_MONO AUDIO_CHANNEL_OUT_STEREO"/>
        </mixPort>
        <mixPort name="primary input" role="sink">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 11025 12000 16000 22050 24000 32000 44100 48000"
                     channelMasks="AUDIO_CHANNEL_IN_MONO AUDIO_CHANNEL_IN_STEREO AUDIO_CHANNEL_IN_FRONT_BACK"/>
        </mixPort>
        <mixPort name="voice recognition" role="sink">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 11025 12000 16000 22050 24000 32000 44100 48000"
                     channelMasks="AUDIO_CHANNEL_IN_MONO AUDIO_CHANNEL_IN_STEREO AUDIO_CHANNEL_IN_FRONT_BACK"/>
        </mixPort>
        <mixPort name="mmap_no_irq_in" role="sink" flags="AUDIO_INPUT_FLAG_MMAP_NOIRQ">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 11025 12000 16000 22050 24000 32000 44100 48000"
                     channelMasks="AUDIO_CHANNEL_IN_MONO AUDIO_CHANNEL_IN_STEREO AUDIO_CHANNEL_IN_FRONT_BACK"/>
        </mixPort>
        <mixPort name="voip_tx" role="sink" flags="AUDIO_INPUT_FLAG_VOIP_TX">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 16000 32000 48000"
                     channelMasks="AUDIO_CHANNEL_IN_MONO AUDIO_CHANNEL_IN_STEREO AUDIO_CHANNEL_IN_FRONT_BACK"/>
        </mixPort>
        <mixPort name="bt_record" role="sink">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 11025 12000 16000 22050 24000 32000 44100 48000"
                     channelMasks="AUDIO_CHANNEL_IN_MONO AUDIO_CHANNEL_IN_STEREO AUDIO_CHANNEL_IN_FRONT_BACK"/>
        </mixPort>
        <mixPort name="fm_record" role="sink">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 11025 12000 16000 22050 24000 32000 44100 48000"
                     channelMasks="AUDIO_CHANNEL_IN_MONO AUDIO_CHANNEL_IN_STEREO AUDIO_CHANNEL_IN_FRONT_BACK"/>
        </mixPort>
    </mixPorts>
    <devicePorts>
        <!-- Output devices declaration, i.e. Sink DEVICE PORT -->
        <devicePort tagName="Earpiece" type="AUDIO_DEVICE_OUT_EARPIECE" role="sink">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="48000" channelMasks="AUDIO_CHANNEL_IN_MONO"/>
        </devicePort>
        <devicePort tagName="Speaker" type="AUDIO_DEVICE_OUT_SPEAKER" role="sink">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="48000" channelMasks="AUDIO_CHANNEL_OUT_STEREO"/>
        </devicePort>
        <devicePort tagName="Wired Headset" type="AUDIO_DEVICE_OUT_WIRED_HEADSET" role="sink">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="48000" channelMasks="AUDIO_CHANNEL_OUT_STEREO"/>
        </devicePort>
        <devicePort tagName="Wired Headphone" type="AUDIO_DEVICE_OUT_WIRED_HEADPHONE" role="sink">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="48000" channelMasks="AUDIO_CHANNEL_OUT_STEREO"/>
        </devicePort>
        <devicePort tagName="BT SCO" type="AUDIO_DEVICE_OUT_BLUETOOTH_SCO" role="sink">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 16000" channelMasks="AUDIO_CHANNEL_OUT_MONO"/>
        </devicePort>
        <devicePort tagName="BT SCO Headset" type="AUDIO_DEVICE_OUT_BLUETOOTH_SCO_HEADSET" role="sink">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 16000" channelMasks="AUDIO_CHANNEL_OUT_MONO"/>
        </devicePort>
        <devicePort tagName="BT SCO Car Kit" type="AUDIO_DEVICE_OUT_BLUETOOTH_SCO_CARKIT" role="sink">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 16000" channelMasks="AUDIO_CHANNEL_OUT_MONO"/>
        </devicePort>
        <devicePort tagName="Built-In Mic" type="AUDIO_DEVICE_IN_BUILTIN_MIC" role="source">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 11025 12000 16000 22050 24000 32000 44100 48000"
                     channelMasks="AUDIO_CHANNEL_IN_MONO AUDIO_CHANNEL_IN_STEREO AUDIO_CHANNEL_IN_FRONT_BACK"/>
        </devicePort>
        <devicePort tagName="Built-In Back Mic" type="AUDIO_DEVICE_IN_BACK_MIC" role="source">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 11025 12000 16000 22050 24000 32000 44100 48000"
                     channelMasks="AUDIO_CHANNEL_IN_MONO AUDIO_CHANNEL_IN_STEREO AUDIO_CHANNEL_IN_FRONT_BACK"/>
        </devicePort>
        <devicePort tagName="Wired Headset Mic" type="AUDIO_DEVICE_IN_WIRED_HEADSET" role="source">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 11025 12000 16000 22050 24000 32000 44100 48000"
                     channelMasks="AUDIO_CHANNEL_IN_MONO AUDIO_CHANNEL_IN_STEREO AUDIO_CHANNEL_IN_FRONT_BACK"/>
        </devicePort>
        <devicePort tagName="BT SCO Headset Mic" type="AUDIO_DEVICE_IN_BLUETOOTH_SCO_HEADSET" role="source">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 16000" channelMasks="AUDIO_CHANNEL_IN_MONO"/>
        </devicePort>
        <devicePort tagName="Telephony Rx" type="AUDIO_DEVICE_IN_TELEPHONY_RX" role="source">
        </devicePort>
        <devicePort tagName="Telephony Tx" type="AUDIO_DEVICE_OUT_TELEPHONY_TX" role="sink">
        </devicePort>
        <devicePort tagName="Fm Record Device" type="AUDIO_DEVICE_IN_FM_TUNER" role="source">
            <profile name="" format="AUDIO_FORMAT_PCM_16_BIT"
                     samplingRates="8000 16000" channelMasks="AUDIO_CHANNEL_IN_MONO"/>
        </devicePort>
        <devicePort tagName="USB Device Out" type="AUDIO_DEVICE_OUT_USB_DEVICE" role="sink"/>
        <devicePort tagName="USB Headset Out" type="AUDIO_DEVICE_OUT_USB_HEADSET" role="sink"/>
        <devicePort tagName="USB Device In" type="AUDIO_DEVICE_IN_USB_DEVICE" role="source"/>
        <devicePort tagName="USB Headset In" type="AUDIO_DEVICE_IN_USB_HEADSET" role="source"/>
    </devicePorts>
    <!-- route declaration, i.e. list all available sources for a given sink -->
    <routes>
        <route type="mix" sink="Earpiece"
               sources="primary output,fast output,mmap_no_irq_out,voip_rx"/>
        <route type="mix" sink="Speaker"
               sources="primary output,fast output,mmap_no_irq_out,voip_rx"/>
        <route type="mix" sink="Wired Headset"
               sources="primary output,fast output,mmap_no_irq_out,voip_rx"/>
        <route type="mix" sink="Wired Headphone"
               sources="primary output,fast output,mmap_no_irq_out,voip_rx"/>
        <route type="mix" sink="USB Device Out"
               sources="primary output,fast output,voip_rx"/>
        <route type="mix" sink="USB Headset Out"
               sources="primary output,fast output,voip_rx"/>
        <route type="mix" sink="BT SCO"
               sources="primary output,fast output,voip_rx"/>
        <route type="mix" sink="BT SCO Headset"
               sources="primary output,fast output,voip_rx"/>
        <route type="mix" sink="BT SCO Car Kit"
               sources="primary output,fast output,voip_rx"/>
        <route type="mix" sink="Telephony Tx"
               sources="incall_music"/>
        <route type="mix" sink="primary input"
               sources="Built-In Mic,Built-In Back Mic,Wired Headset Mic,USB Device In,USB Headset In,Telephony Rx"/>
        <route type="mix" sink="voice recognition"
               sources="Built-In Mic,Built-In Back Mic,Wired Headset Mic,USB Device In,USB Headset In"/>
        <route type="mix" sink="mmap_no_irq_in"
               sources="Built-In Mic,Built-In Back Mic,Wired Headset Mic"/>
        <route type="mix" sink="voip_tx"
               sources="Built-In Mic,Built-In Back Mic,Wired Headset Mic,BT SCO Headset Mic,USB Device In,USB Headset In"/>
        <route type="mix" sink="bt_record"
               sources="BT SCO Headset Mic"/>
        <route type="mix" sink="fm_record"
               sources="Fm Record Device"/>
    </routes>
</module>
